# -*- coding: utf-8 -*-
"""
Created on Mon Aug  7 09:07:06 2023

@author: kerb930
"""

import pandas as pd
from itertools import chain
import numpy as np

# #-----------------------------------------------------------------------------
# # Memphis Light, Gas, and Water - TN
# #-----------------------------------------------------------------------------
# state = 'TN'
# #winter Dec - Mar
# #w_on = 4AM-10AM
# #w_off = else

# w_onStart = 4
# w_offStart = 10

# w_onPrice = .09891
# w_offPrice = .06584

# rate = []
# idx = 0
# while idx < w_onStart:
#     rate.append(w_offPrice)
#     idx += 1
# idx = w_onStart
# while idx < w_offStart:
#     rate.append(w_onPrice)
#     idx += 1
# idx = w_offStart
# while idx < 24:
#     rate.append(w_offPrice)
#     idx += 1
    
# w_weekend = []
# k = 0
# while k < 24:
#     w_weekend.append(w_offPrice)
#     k += 1

# w_weekRate = []
# w_weekRate.append(w_weekend)
# w_weekRate.append(rate*5)
# w_weekRate.append(w_weekend)
# w_weekRate = list(chain.from_iterable(w_weekRate))

# yearRate = []
# yearRate.append(w_weekRate*12)
# yearRate.append(w_weekend)
# yearRate.append(rate*5) #--> through end of March


# #Spring April 1 - May 31
# # off peak -> always w_weekend
# yearRate.append(w_weekend)
# yearRate.append(w_weekend*7*8)
# yearRate.append(w_weekend*4)

# #Summer June 1 - Sept 30
# #s_on = 1PM-7PM weekdays - 13 - 19
# #s_off = else, weekends

# s_onStart = 13
# s_offStart = 19

# s_onPrice = .14597
# s_offPrice = .06584


# s_rate = []
# idx = 0
# while idx < s_onStart:
#     s_rate.append(s_offPrice)
#     idx += 1
# idx = s_onStart
# while idx < s_offStart:
#     s_rate.append(s_onPrice)
#     idx += 1
# idx = s_offStart
# while idx < 24:
#     s_rate.append(s_offPrice)
#     idx += 1

# s_weekRate = []
# s_weekRate.append(w_weekend)
# s_weekRate.append(s_rate*5)
# s_weekRate.append(w_weekend)
# s_weekRate = list(chain.from_iterable(s_weekRate))

# yearRate.append(s_rate*2)
# yearRate.append(w_weekend)
# yearRate.append(s_weekRate*17)

# #Fall Oct 1 - Nov 30

# yearRate.append(w_weekend*61)

# #Winter Dec 31
# yearRate.append(rate)
# yearRate.append(w_weekend)
# yearRate.append(w_weekRate*4)
# yearRate.append(w_weekend)
# yearRate = list(chain.from_iterable(yearRate))



# #-----------------------------------------------------------------------------
# # Eversource - MA
# #-----------------------------------------------------------------------------
# state = 'MA'
# #on = 1PM-7PM, M-F --> 13-19
# #off = 7PM-1PM, M-F --> 19+, All Sat, Sun

# onStart = 13
# offStart = 19

# onPrice = .14367 + .16473
# offPrice = .04123 + .05942

# rate = []
# idx = 0
# while idx < onStart:
#     rate.append(offPrice)
#     idx += 1
# idx = onStart
# while idx < offStart:
#     rate.append(onPrice)
#     idx += 1
# idx = offStart
# while idx < 24:
#     rate.append(offPrice)
#     idx += 1
    
# weekend = []
# k = 0
# while k < 24:
#     weekend.append(offPrice)
#     k += 1

# weekRate = []
# weekRate.append(weekend)
# weekRate.append(rate*5)
# weekRate.append(weekend)
# weekRate = list(chain.from_iterable(weekRate))

# yearRate = []
# yearRate.append(weekRate*52)
# yearRate.append(rate)
# yearRate = list(chain.from_iterable(yearRate))


# #-----------------------------------------------------------------------------
# #Xcel Energy - Colorado | Summer June 1 - Sept 30, Winter Oct 1 - May 31
# #-----------------------------------------------------------------------------
# state = 'CO'
# #on = 3PM-7PM --> 15-19
# #mid = 1PM-3PM ---> 13-15
# #off = else --> weekends

# onStart = 15
# midStart = 13
# offStart = 19

# s_onPrice = .17246
# s_midPrice = .11816
# s_offPrice = .06387

# s_rate = []
# idx = 0
# while idx < midStart:
#     s_rate.append(s_offPrice)
#     idx += 1
# idx = midStart
# while idx < onStart:
#     s_rate.append(s_midPrice)
#     idx += 1
# idx = onStart
# while idx < offStart:
#     s_rate.append(s_onPrice)
#     idx += 1
# idx = offStart
# while idx < 24:
#     s_rate.append(s_offPrice)
#     idx += 1
    
# weekend = []
# k = 0
# while k < 24:
#     weekend.append(s_offPrice)
#     k += 1

# s_weekRate = []
# s_weekRate.append(weekend)
# s_weekRate.append(s_rate*5)
# s_weekRate.append(weekend)
# s_weekRate = list(chain.from_iterable(s_weekRate))

# w_onPrice = .10858
# w_midPrice = .08623
# w_offPrice = .06387

# w_rate = []
# idx = 0
# while idx < midStart:
#     w_rate.append(w_offPrice)
#     idx += 1
# idx = midStart
# while idx < onStart:
#     w_rate.append(w_midPrice)
#     idx += 1
# idx = onStart
# while idx < offStart:
#     w_rate.append(w_onPrice)
#     idx += 1
# idx = offStart
# while idx < 24:
#     w_rate.append(w_offPrice)
#     idx += 1
    
# weekend = []
# k = 0
# while k < 24:
#     weekend.append(s_offPrice)
#     k += 1

# w_weekRate = []
# w_weekRate.append(weekend)
# w_weekRate.append(w_rate*5)
# w_weekRate.append(weekend)
# w_weekRate = list(chain.from_iterable(w_weekRate))

# yearRate = []
# yearRate.append(w_weekRate*21)
# yearRate.append(weekend) 
# yearRate.append(w_rate*3) 
# yearRate.append(s_rate*2)
# yearRate.append(weekend)
# yearRate.append(s_weekRate*17)
# yearRate.append(w_weekRate*13)
# yearRate.append(weekend)
# yearRate = list(chain.from_iterable(yearRate))

# #-----------------------------------------------------------------------------
# # Alabama Power
# #-----------------------------------------------------------------------------
# state = 'AL'
# #winter
# #w_on = 5AM-9AM
# #w_off = else

# w_onStart = 5
# w_offStart = 9

# w_onPrice = .112595
# w_offPrice = .092595

# rate = []
# idx = 0
# while idx < w_onStart:
#     rate.append(w_offPrice)
#     idx += 1
# idx = w_onStart
# while idx < w_offStart:
#     rate.append(w_onPrice)
#     idx += 1
# idx = w_offStart
# while idx < 24:
#     rate.append(w_offPrice)
#     idx += 1
    
# w_weekend = []
# k = 0
# while k < 24:
#     w_weekend.append(w_offPrice)
#     k += 1

# w_weekRate = []
# w_weekRate.append(w_weekend)
# w_weekRate.append(rate*5)
# w_weekRate.append(w_weekend)
# w_weekRate = list(chain.from_iterable(w_weekRate))

# yearRate = []
# yearRate.append(w_weekRate*12)
# yearRate.append(w_weekend)
# yearRate.append(rate*5) #--> through end of March


# #Spring April 1 - May 31
# # off peak -> always w_weekend
# yearRate.append(w_weekend)
# yearRate.append(w_weekend*7*8)
# yearRate.append(w_weekend*4)

# #Summer June 1 - Sept 30
# #s_on = 1PM-7PM weekdays - 13 - 19
# #s_off = else, weekends

# s_onStart = 13
# s_offStart = 19

# s_onPrice = .292595
# s_offPrice = .092595


# s_rate = []
# idx = 0
# while idx < s_onStart:
#     s_rate.append(s_offPrice)
#     idx += 1
# idx = s_onStart
# while idx < s_offStart:
#     s_rate.append(s_onPrice)
#     idx += 1
# idx = s_offStart
# while idx < 24:
#     s_rate.append(s_offPrice)
#     idx += 1

# s_weekRate = []
# s_weekRate.append(w_weekend)
# s_weekRate.append(s_rate*5)
# s_weekRate.append(w_weekend)
# s_weekRate = list(chain.from_iterable(s_weekRate))

# yearRate.append(s_rate*2)
# yearRate.append(w_weekend)
# yearRate.append(s_weekRate*17)

# #Fall Oct 1 - Oct 31

# yearRate.append(w_weekend*31)

# #Winter Nov 1 - Dec 31
# yearRate.append(rate*3)
# yearRate.append(w_weekend)
# yearRate.append(w_weekRate*8)
# yearRate.append(w_weekend)
# yearRate = list(chain.from_iterable(yearRate))


# #-----------------------------------------------------------------------------
# # Alabama Power - PV RATE
# #-----------------------------------------------------------------------------
state = 'AL_PV'
#winter
#w_on = 5AM-9AM
#w_off = else

w_onStart = 5
w_offStart = 9

w_onPrice = .0484
w_offPrice = .0440

rate = []
idx = 0
while idx < w_onStart:
    rate.append(w_offPrice)
    idx += 1
idx = w_onStart
while idx < w_offStart:
    rate.append(w_onPrice)
    idx += 1
idx = w_offStart
while idx < 24:
    rate.append(w_offPrice)
    idx += 1
    
w_weekend = []
k = 0
while k < 24:
    w_weekend.append(w_offPrice)
    k += 1

w_weekRate = []
w_weekRate.append(w_weekend)
w_weekRate.append(rate*5)
w_weekRate.append(w_weekend)
w_weekRate = list(chain.from_iterable(w_weekRate))

yearRate = []
yearRate.append(w_weekRate*12)
yearRate.append(w_weekend)
yearRate.append(rate*5) #--> through end of March


#Spring April 1 - May 31
# off peak -> always w_weekend

spfl_price = .0482
spfl = []
k = 0
while k < 24:
    spfl.append(spfl_price)
    k += 1

yearRate.append(spfl)
yearRate.append(spfl*7*8)
yearRate.append(spfl*4)

#Summer June 1 - Sept 30
#s_on = 1PM-7PM weekdays - 13 - 19
#s_off = else, weekends

s_onStart = 13
s_offStart = 19

s_onPrice = .0769
s_offPrice = .0556


s_rate = []
idx = 0
while idx < s_onStart:
    s_rate.append(s_offPrice)
    idx += 1
idx = s_onStart
while idx < s_offStart:
    s_rate.append(s_onPrice)
    idx += 1
idx = s_offStart
while idx < 24:
    s_rate.append(s_offPrice)
    idx += 1

s_weekRate = []
s_weekRate.append(w_weekend)
s_weekRate.append(s_rate*5)
s_weekRate.append(w_weekend)
s_weekRate = list(chain.from_iterable(s_weekRate))

yearRate.append(s_rate*2)
yearRate.append(w_weekend)
yearRate.append(s_weekRate*17)

#Fall Oct 1 - Oct 31

yearRate.append(spfl*31)

#Winter Nov 1 - Dec 31
yearRate.append(rate*3)
yearRate.append(w_weekend)
yearRate.append(w_weekRate*8)
yearRate.append(w_weekend)
yearRate = list(chain.from_iterable(yearRate))


# #-----------------------------------------------------------------------------
# # Georgia Power 
# #-----------------------------------------------------------------------------
# state = 'GA'
# #on = 2PM-7PM June through Sept, M-F --> 14 - 19
# #off = else --> 

# onStart = 14
# offStart = 19

# onPrice = .110060
# offPrice = .011766


# rate = []
# idx = 0
# while idx < onStart:
#     rate.append(offPrice)
#     idx += 1
# idx = onStart
# while idx < offStart:
#     rate.append(onPrice)
#     idx += 1
# idx = offStart
# while idx < 24:
#     rate.append(offPrice)
#     idx += 1
    
# weekend = []
# k = 0
# while k < 24:
#     weekend.append(offPrice)
#     k += 1

# weekRate = []
# weekRate.append(weekend)
# weekRate.append(rate*5)
# weekRate.append(weekend)
# weekRate = list(chain.from_iterable(weekRate))

# offrate = []
# offrate.append(weekend*7)
# offrate = list(chain.from_iterable(offrate))

# yearRate = []
# yearRate.append(offrate*21)
# yearRate.append(weekend*4)
# yearRate.append(rate*2)
# yearRate.append(weekend) #--> this brings it through June 3rd (Sat)
# yearRate.append(weekRate*17) #--> through end of Sept
# yearRate.append(weekend*7*13)
# yearRate.append(weekend)
# yearRate = list(chain.from_iterable(yearRate))

#-----------------------------------------------------------------------------
# PGE 
#-----------------------------------------------------------------------------

# #on = 5PM-9PM, M-F --> 17-21
# #mid = 7AM-5PM, M-F --> 7-17
# #off = 9PM-7AM, M-F --> 21-7, All Sat, Sun

# midStart = 7
# onStart = 17
# offStart = 21

# onPrice = .22261
# midPrice = .16896
# offPrice = .04123


# rate = []
# idx = 0
# while idx < midStart:
#     rate.append(offPrice)
#     idx += 1
# idx = midStart
# while idx < onStart:
#     rate.append(midPrice)
#     idx += 1
# idx = onStart
# while idx < offStart:
#     rate.append(onPrice)
#     idx += 1
# idx = offStart
# while idx < 24:
#     rate.append(offPrice)
#     idx += 1
    
# weekend = []
# k = 0
# while k < 24:
#     weekend.append(offPrice)
#     k += 1

# weekRate = []
# weekRate.append(weekend)
# weekRate.append(rate*5)
# weekRate.append(weekend)
# weekRate = list(chain.from_iterable(weekRate))

# yearRate = []
# yearRate.append(weekRate*52)
# yearRate.append(rate)
# yearRate = list(chain.from_iterable(yearRate))

tou = {'rate': yearRate}
df = pd.DataFrame(tou)
df.to_csv(state + 'tou.csv', index=False, header=False)


